#!/usr/bin/python
# -*- coding: ISO-8859-1 -*-
import controller
from cgi import escape
from urllib import urlopen
from cStringIO import StringIO

def firstPage(name, nameError, email, emailError, fileDiskError, fileUrl, fileUrlError):
    return """<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fi" >
  <head>
    <link href="style.css" rel="StyleSheet" type="text/css" />
    <script src="file_input_changer.js" type="text/javascript"></script>
    <title>Harkkatarkastin</title>
  </head>
  <body id="main">
    <h1>Harkkatarkastin</h1>
    <form action="" method="post" enctype="multipart/form-data">
      <fieldset>
        <legend>Harjoitustyn tiedot</legend>
        <p  class="evenTextBox">
          <label for="name">Tekijn nimi:</label>
          <input type="text" id="name" name="name" size="50" value="%s"/>
          <span class="error">%s</span>
        </p>
        <p class="evenTextBox">
          <label for="email">Shkposti:</label>
          <input type="text" id="email" name="email" size="50" value ="%s"/>
          <span class="error">%s</span>
        </p>
        <p>Tiedoston lataus:</p> 
        <p class="evenFileInput">
          <input id="radioDisk" type="radio" value="file" name="fileInputSelection" checked="checked"/>
          <label for="radioDisk">Levylt:</label>               
          <input class="" type="file" id="filerequest" name="filerequest" />
          <span class="error">%s</span>
        </p>
        <p class="evenFileInput" >
          <input id="radioUrl" type="radio" value="url" name="fileInputSelection"/>
          <label for="radioUrl">URL:</label>        
          <input class="hidden" type="text" id="fileUrl" name="fileUrl" size="50" value="%s" />
          <span class="error">%s</span>
        </p>
        <p class="evenInput">
          <input type="submit" id="submitButton" name="submitButton" value="Tarkasta!" />
        </p>
      </fieldset>
    </form>
  </body>
</html>
""" % (name, nameError, email, emailError, fileDiskError, fileUrl, fileUrlError)

def feedBackPage(feedback, name, email):
    page = """<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fi" >
  <head>
    <link href="tyyli.css" rel="StyleSheet" type="text/css" />
    <title>Harkkatarkastin</title>
  </head>
  <body>
    <h1>Palaute</h1>
    <p>
        Nimi: %s <br/>
        Shkposti: %s <input type="button" id="sendToEmailButton" name="" value="Lhet palaute mys shkpostiin" />
    </p>
""" % (name, email)

    for msg in feedback:
        page += msg

    page += """</body>
  </html>
"""
    return page

def index(req):
    req.content_type = "text/html"
    form = req.form
    feedback = []
    name = form.getfirst("name")
    email = form.getfirst("email")
    sent = form.getfirst("submitButton")
    fileUrl = form.getfirst("fileUrl")
    radioValue = form.getfirst("fileInputSelection")
    #feedback.append(name)
    
    if sent:
        #feedback.append("Nimi: " + name)
        #feedback.append("Shkpostiosoite: " + email)
        nameError = ""
        emailError = ""
        goForward = True
        
        if name == "" or name == None:
            nameError = "* Pakollinen kentt!"
            goForward = False
        if  email == "" or email == None:
            emailError = "* Pakollinen kentt!"
            goForward = False
        if goForward:
            tmpfile = None
            if radioValue.value == "file":
                tmpfile = req.form['filerequest']
                
                if tmpfile.filename == "":
                    inputError = "* Tiedostoa ei lytynyt!"
                    return firstPage(escape(name), nameError, escape(email), emailError, inputError, escape(fileUrl), "")
                controller.beginInspection(tmpfile.file, tmpfile.filename, feedback)
                
            elif radioValue.value == "url":
                try:                
                    tmpfile = urlopen(fileUrl)
                    controller.beginInspection(StringIO(tmpfile.read()), fileUrl, feedback)
                except IOError:
                	inputError = "* Url-osoite oli vrin!"
                	return firstPage(escape(name), nameError, escape(email), emailError, "", escape(fileUrl), inputError)
            #else: then what?
            
            return feedBackPage(feedback, escape(name), escape(email))
            
        else:
            sent = None
            return firstPage(escape(name), nameError, escape(email), emailError, "", escape(fileUrl), "")
    return firstPage("", "", "", "", "", "http://", "")
